
// Real-time reverse emulation support layer

// Copyright (C) 2005 Shay Green. MIT license.

#ifndef REVERSE_EMULATION_H
#define REVERSE_EMULATION_H

#ifdef __cplusplus
extern "C" {
#endif

// Set size of frame buffer and reset internal state. Should be called when resetting
// the emulator.
void re_init( int );

// Run emulation forward one frame and return buffer index to be displayed
int re_next_frame();

// Run emulation backwards one frame and return buffer index to be displayed
int re_prev_frame();

// Defined in user code

void emu_save_state( int n );     // save to snapshot n
void emu_restore_state( int n );  // restore snapshot n
void emu_run_frame( int n );      // emulate one frame into buffer [n]
void emu_run_frame_invisibly();   // emulate one frame without audio/video

#ifdef __cplusplus
}
#endif

#endif

